# 30 带注解的参考书目

> 原文： [30 Annotated bibliography](https://serialmentor.com/dataviz/bibliography.html)

> 校验：[飞龙](https://github.com/wizardforcel)

> 自豪地采用[谷歌翻译](https://translate.google.cn/)

没有一本书可以涵盖有关主题的所有内容。我鼓励您阅读有关数据可视化的其他书籍，来加深您的理解并培养您制作图形的技术技能。在这里，我提供了一些有限的书籍，我个人觉得这些书很有趣，发人深省或有帮助。 30.1 节中列出的书籍与本书的范围最相似，可以提供我所涵盖的主题的补充或替代观点。30.2 节中列出的书籍讲述了如何使用编程方法和可用软件库进行可视化的重要主题。其余部分列出了其他书籍，这些书籍将扩展您对数据可视化的知识，并帮助您使用视觉和数据进行沟通。

## 30.1 思考数据和可视化

以下书籍讨论了将数据转换为可视化所需的思考过程和决策。它们作为介绍性书籍，介绍如何选择要制作的可视化以及需要注意的陷阱。

*   ```
    Alberto Cairo. “The Truthful Art.” New Riders, 2016.
    ```
    数据可视化的全方位介绍，特别是对于报告者。本书涵盖了数据可视化的许多重要概念，例如如何可视化分布，趋势，不确定性和地图。在许多章节中，本书还介绍了基本统计原理，解释了总体，样本和置信水平等概念。

*   ```
    Stephen Few. “Show Me the Numbers.” Analytics Press, 2012.
    ```
    
    一本关于商业专业人士数据可视化的书。它的范围和目标受众与 Nussbaumer Knaflic 的书相似（见下文）。然而，很少有书包含更多材料，更深入地涵盖了许多主题。与此同时，这本书不像 Nussbaumer Knaflic 书那样精心编写和精心制作。

*   ```
    Cole Nussbaumer Knaflic. “Storytelling with Data.” John Wiley & Sons, 2015.
    ```
    一本精心编写并精心制作的书，关于如何将数据转换为视觉效果。这本书的主要受众是制作商业图形的人，这本书非常适合它所涵盖的主题。然而，这本书缺少许多对科学家来说很重要的主题，例如分布，趋势或不确定性的可视化。

## 30.2 编程书籍

以下书籍是教授数据可视化编程方法的所有书籍。

*   ```
    Kieran Healy. “Data Visualization: A Practical Introduction.” Princeton University Press, 2018.
    ```
    
    使用 ggplot2 进行数据可视化的介绍。推荐在 Wickham 和 Grolemund 的“R for Data Science”之后阅读（见下文）。

*   ```
    Scott Murray. “Interactive Data Visualization for the Web: An Introduction to Designing with D3, 2nd Edition.” O’Reilly Media, 2017.
    ```
    
    使用 HTML，CSS，JavaScript 和 SVG，使用 D3 进行交互式在线可视化的简介。

*   ```
    Jake VanderPlas. “Python Data Science Handbook: Essential Tools for Working with Data.” O’Reilly Media, 2016.
    ```
    
    使用 Python 编程语言进行数据科学的介绍。带有使用 Python 的 Matplotlib 和 Seaborn 进行数据可视化的广泛材料。

*   ```
    Hadley Wickham, Garrett Grolemund. “R for Data Science.” O’Reilly Media, 2017.
    ```
    
    全面介绍如何使用编程语言 R 进行数据科学。包含有关使用 ggplot2 进行数据可视化的几个章节。

## 30.3 统计书籍

统计学中的介绍性书籍通常包含有关数据可视化的材料，涵盖散点图，直方图，箱形图和折线图等主题。有许多这样的书籍可以列出。在这里，我只提到一些值得仔细研究的近期补充内容。

*   ```
    David M. Diez, Christopher D. Barr, Mine Çetinkaya-Rundel. “OpenIntro Statistics, 3rd Edition.” OpenIntro, Inc., 2015.
    ```
    
    开源入门统计教科书。整本书都是免费提供的，LaTeX 文件和用于编写书籍和制作图形的 R 代码也是免费提供的。

*   ```
    Susan Holmes, Wolfgang Huber. “Modern Statistics for Modern Biology.” 2018.
    ```
    
    一个统计学书籍，强调现代生物学所需的计算工具。整本书免费提供，并提供所有示例的 R 代码。

## 30.4 历史书籍

本节中的书籍主要是出于历史原因。它们在出版时具有影响力，但现在可以在其他地方或以更现代的形式找到类似的材料。

*   ```
    William S. Cleveland. “Visualizing Data.” Hobart Press, 1993.
    ```
    相同作者的“The Elements of Graphing Data”的配套书（见下文）。这个更具数学性，不谈人类感知。

*   ```
    William S. Cleveland. “The Elements of Graphing Data, 2nd Edition.” Hobart Press, 1994.
    ```
    
    为统计学家编写的第一本关于信息设计的书籍之一。本书包含许多散点图，折线图，直方图和箱线图的例子，并在数据分析和统计建模的背景下讨论它们。它还推广了克利夫兰点图。

*   ```
    Edward R. Tufte. “Envisioning Information.” Graphics Press, 1990.
    ```
    
    这本书推广了小型多图的概念。

*   ```
    Edward R. Tufte. “The Visual Display of Quantitative Information, 2nd Edition.” Graphics Press, 2001.
    ```
    
    本书于 1983 年首次出版，在数据可视化领域具有极大的影响力。它引入了图形垃圾，数据墨水比和迷你图等概念。这本书还展示了第一个斜率图（但没有命名）。然而，该书还包含许多经得起时间考验的建议。特别是，它建议过度简约的绘图设计。

## 30.5 广泛相关主题的书籍

以下书籍与数据可视化和有效沟通的主题大致相关。

*   ```
    Joshua Schimel. “Writing Science.” Oxford University Press, 2011.
    ```
    
    通过讲故事来讲授如何以引人入胜的方式撰写科学和其他技术主题。虽然不是主要关于数据可视化的书，但对于需要撰写技术文章和/或提案的人来说，这是一本不可或缺的书籍。

*   ```
    Jonathan Schwabish. “Better Presentations.” Columbia University Press, 2016.
    ```
    
    简短而翔实的演讲指南。对于经常使用幻灯片进行演讲或演示的人来说必读。

*   ```
    Maureen C. Stone. “A Field Guide to Digital Color.” A K Peters, 2003.
    ```
    
    计算机如何捕获，处理和再现颜色的综合指南。

*   ```
    Colin Ware. “Information Visualization, 3rd Edition.” Morgan Kaufmann, 2012.
    ```
    
    一本关于可视化原理的书，专门讨论人类视觉系统如何工作，以及如何感知不同图形模式等主题。本书涵盖了许多不同的可视化场景，包括用户界面和虚拟世界，但它相对较少强调以 2D 图形的形式可视化数据。